#include <iostream>
#include <iostream>
#include <iomanip>
#include <cmath>
#include "nr.h"
#include <vector>
#include <stdio.h> 
#include <time.h>
#include <math.h>

#include <stdlib.h>
#include <assert.h>
#include <stdio.h>
# include "asa047.H"
# include "minpack.H"

using namespace std;

//***********//
//parameters:
//***********//
double beta = 0.96;
double theta = 0.36; //theta, capital share
double delta, ind_delta;
int N_d;
double alpha_p = 0.13;
double alpha_c = 0.30;
double a_h = 1.024;
double a_l = 0.976;    
double a0, a0_in;
double p11, p12, p21, p22;
double pi_1, pi_2;    

const int Nk = 800; 
int Ntauk;
int Ntaul = 2;
double tau_step = 0.001;

double kl, kh, tauk_b, taul_b, tauk_a, taul_a;
double k_vec[Nk];

double k0, k1, l0, l1, c0, c1;
double tauk0, tauk1, taul0, taul1;
double k0_in, tauk0_in, taul0_in; 
int shk0_in;
 
//shocks:      
const int N_shk = 2;
int shk0, shk1;     
double pi[N_shk][N_shk];
double a_vec[N_shk];

double policy_c_0[Nk][N_shk], policy_l_0[Nk][N_shk], policy_k1_0[Nk][N_shk], policy_tk_0[Nk][N_shk], policy_tl_0[Nk][N_shk]; 
double policy_c_1[Nk][N_shk], policy_l_1[Nk][N_shk], policy_k1_1[Nk][N_shk], policy_tk_1[Nk][N_shk], policy_tl_1[Nk][N_shk];
double v0[Nk][N_shk], v1[Nk][N_shk];
         
double tol_eul = 1e-3;

const int N_rnd = 1000;
double rnd_vec[N_rnd];
double out_m_k[6];

void policy_input1()  // import the initial policy functions.
{
        //int k,l;
		string txt;
        ifstream fp("policy_mpe_input_delta_1.txt");

		
		for (int i_rho=0; i_rho<N_shk; i_rho++){	
			for (int i_k=0; i_k<Nk; i_k++){   

					double debug0, debug1, debug2, debug3, debug4, debug5, debug6, debug7;
					
					fp>>debug1>>debug2>>debug3>>debug4>>debug5>>debug6>>debug7;

					policy_k1_1[i_k][i_rho] = debug2;
					policy_c_1[i_k][i_rho] = debug3;
					policy_l_1[i_k][i_rho] = debug4;
					policy_tk_1[i_k][i_rho] = debug5;
					policy_tl_1[i_k][i_rho] = debug6;
					v1[i_k][i_rho] = debug7;				
			}
		} 
       fp.close();        
}

bool check_euler() //covergence tolerance.
{
		bool ans = true;
		for (int i_rho=0; i_rho<N_shk; i_rho++){	
			for (int i_k=0; i_k<Nk; i_k++){  

					if (
						fabs(v1[i_k][i_rho]-v0[i_k][i_rho])>tol_eul ) {
						return false;
					}  

			}
		}
	return ans;
}

void NRlocate(double xx[], int size, double x, int &j)
{
	int ju,jm,jl;
	bool ascnd;

	int n=size;
	jl=-1;
	ju=n;
	ascnd=(xx[n-1] >= xx[0]);
	while (ju-jl > 1) {
		jm=(ju+jl) >> 1;
		if (x >= xx[jm] == ascnd)
			jl=jm;
		else
			ju=jm;
	}
	if (x == xx[0]) j=0;
	else if (x == xx[n-1]) j=n-2;
	else j=jl;
}

double intp_1d(double &x_k, int &shk, double policy[Nk][N_shk])
{   
	int i_k;	
	NRlocate(k_vec, Nk, x_k, i_k);
    if (i_k==-1){i_k = 0;}
	if (i_k==Nk-1){i_k = Nk-2;}
		
	return policy[i_k][shk] + (policy[i_k+1][shk]-policy[i_k][shk])
		/(k_vec[i_k+1] - k_vec[i_k])*(x_k - k_vec[i_k]);	
}  
     
double expt_v(int &shk0_i, double &k1_i)
//get the E(u'(c+))
{
	double e_v = 0.0;
	double tmp_v = 0.0;

	for (int i_shk0=0; i_shk0<N_shk; i_shk0++){	
		if (i_shk0 == shk0_i){
			for (int i_shk1=0; i_shk1<N_shk; i_shk1++){	

				tmp_v = intp_1d(k1_i, i_shk1, v0); 

				e_v += pi[i_shk0][i_shk1]*tmp_v;    
				//cout<<e_uc<<endl;
			}
		}
	}
	return e_v;
}  
//************************************************************************** 

//**************************************************************************
double next_uc(int &shk1_i, double &k1_i)
//get u'(c+) 
{
	double tau_k1_i, tau_l1_i, c1_i, l1_i, k2_i;
	
	l1_i = intp_1d(k1_i, shk1_i, policy_l_0); 
	tau_k1_i = intp_1d(k1_i, shk1_i, policy_tk_0);
	tau_l1_i = 0.0;  //intp_1d(k1_i, shk1_i, policy_tl_0);
	
	double r1_i, w1_i, g1_i, tmp_f1, tmp_f2, tmp_f3;

	r1_i = a_vec[shk1_i]*theta*pow(k1_i/l1_i,theta-1.0);
	w1_i = a_vec[shk1_i]*(1.0-theta)*pow(k1_i/l1_i,theta);
	c1_i = alpha_c/(1.0-alpha_c)*(1.0-tau_l1_i)*w1_i*(1.0-l1_i);	

	double tmp1, tmp2;
	tmp1 = (1.0-tau_k1_i) * r1_i - delta + ind_delta * tau_k1_i * delta; 
	return (1.0+tmp1) / c1_i;
}

double expt_uc(int &shk0_i, double &k1_i)
//get the E(u'(c+))
{
	double e_uc = 0.0;

	for (int i_shk0=0; i_shk0<N_shk; i_shk0++){	
		if (i_shk0 == shk0_i){
			for (int i_shk1=0; i_shk1<N_shk; i_shk1++){	
				e_uc += pi[i_shk0][i_shk1]*next_uc(i_shk1, k1_i);    
				//cout<<e_uc<<endl;
			}
		}
	}
	return e_uc;
}  
//************************************************************************** 

double f_m_k_brent (DP x)
{
	double x_la;   
	double pent = 0.0;
	
	x_la = x; 
		
	//m_in;
	double x_w0, x_r0, x_c0, x_euc, x_ul;
	double x_k1;
	x_w0 = a0_in*(1.0-theta)*pow(k0_in/x_la, theta);
	x_r0 = a0_in*theta*pow(k0_in/x_la, theta-1.0);

	x_c0 = alpha_c/(1.0-alpha_c)*(1.0-taul0_in)*x_w0*(1.0-x_la);
	x_k1 = (1.0-tauk0_in)*x_r0*k0_in + (1.0-delta)*k0_in + ind_delta*tauk0_in*delta*k0_in + (1.0-taul0_in)*x_w0*x_la - x_c0;

	x_euc = expt_uc(shk0_in, x_k1);

	return fabs(1.0/x_c0 - beta*x_euc); // * (1.0- x_c0 * beta*x_euc);// + pent;
} 

void m_k(double &x_k0, int &x_shk0, double &x_tau_k, double &x_tau_l)
{
	if (x_shk0 == 0){
		a0_in = a_l;
	}
	if (x_shk0 == 1){
		a0_in = a_h;
	}
	tauk0_in = x_tau_k;
	taul0_in = x_tau_l;
	
	k0_in = x_k0;
	shk0_in = x_shk0;
	                                       
	const DP TOL=1.0e-12,EQL=1.0e-10;
	bool newroot;
	int j;
	int nmin=0;
	DP ax, bx, cx;
	DP xmin1, xmin2;
	Vec_DP amin(60);
	
	ax=0.1;
	bx=0.33;
	cx=0.6;
	
	NR::brent(ax,bx,cx,f_m_k_brent,TOL,xmin1);
	if (nmin == 0) {
		amin[nmin++]=xmin1;
	} else {
		newroot=true;
		for (j=0;j<nmin;j++){
			if (fabs(xmin1-amin[j]) <= (EQL*xmin1)) newroot=false;
			if (newroot) {
				amin[nmin++]=xmin1;
			}
		}
	}  

	double x_w0, x_r0, x_c0, x_u0, x_g, x_ug;
	double x_k1, x_la;
	double e_v1;
	
	x_la = xmin1;  

	x_w0 = a0_in*(1.0-theta)*pow(k0_in/x_la, theta);
	x_r0 = a0_in*theta*pow(k0_in/x_la, theta-1.0);

	x_c0 = alpha_c/(1.0-alpha_c)*(1.0-taul0_in)*x_w0*(1.0-x_la);
	x_k1 = (1.0-tauk0_in)*x_r0*k0_in + (1.0-delta)*k0_in + ind_delta*tauk0_in*delta*k0_in + (1.0-taul0_in)*x_w0*x_la - x_c0;

	e_v1 = expt_v(shk0_in, x_k1);

	x_u0 = (1.0-beta)* ( (1.0-alpha_p)*alpha_c*log(x_c0) + (1.0-alpha_p)*(1.0-alpha_c)*log(1.0-x_la) );
	x_g = taul0_in*x_w0*x_la + tauk0_in*(x_r0-ind_delta*delta)*k0_in;
	x_ug = (1.0-beta)*alpha_p*log(x_g);

	out_m_k[0] = x_k1;             //k+
	out_m_k[1] = x_la;             //l
	out_m_k[2] = x_c0;                //uc
	out_m_k[3] = x_g;
	out_m_k[4] = x_u0 + x_ug + beta*e_v1;         //u
	out_m_k[5] = f_m_k_brent(xmin1);     //fvec
}

void policy_eul_compute()
{
	//static 
	ofstream file("policy_mpe.txt");
	file.precision(4);

	double tmp_v0, tmp_vh;

	for (int i_shk=0; i_shk<N_shk; i_shk++){	
		for (int i_k=0; i_k<Nk; i_k++){
			
			tmp_vh = -1000.0;

			tauk0 = tauk_a - tau_step;
			do{
			tauk0 += (tauk_b - tauk_a)/Ntauk;
			
				taul0 = taul_a;
				do{				
					taul0 += (taul_b - taul_a)/Ntaul;			
            
					k0 = k_vec[i_k];
					//shk0 = i_shk;  

					m_k(k0, i_shk, tauk0, taul0);
					tmp_v0 = out_m_k[4];// - 1e3*(out_m_k[5]);  //pent for constraints

					if (out_m_k[5] < 1e-9){										
						if (tmp_v0 > tmp_vh){
							policy_k1_1[i_k][i_shk] = out_m_k[0];
							policy_l_1[i_k][i_shk] = out_m_k[1];
							policy_c_1[i_k][i_shk] = out_m_k[2];
							policy_tk_1[i_k][i_shk] = tauk0;
							policy_tl_1[i_k][i_shk] = taul0;
							
							tmp_vh = tmp_v0;
							v1[i_k][i_shk] = out_m_k[4];  //tmp_v0;
						}	
					}					
				}while (taul0 < taul_b);
			}while (tauk0 < tauk_b);
		}//end i_k
	}//end i_shk
//print out policy functions:
}

void print_policy()
{
    //static 
	ofstream file("policy_mpe_output.txt");

	double tmp_tk = -1.0;
    for (int i_shk=0; i_shk<N_shk; i_shk++){	
		for (int i_k=0; i_k<Nk; i_k++){

			if (policy_tk_1[i_k][i_shk] > tmp_tk){
				tmp_tk = policy_tk_1[i_k][i_shk] ;
			}
			file<<k_vec[i_k]<<" "
				<<policy_k1_1[i_k][i_shk]<<" "
				<<policy_l_1[i_k][i_shk]<<" "
				<<policy_c_1[i_k][i_shk]<<" "
				<<policy_tk_1[i_k][i_shk]<<" "
				<<policy_tl_1[i_k][i_shk]<<" "
				<<v1[i_k][i_shk]<<" "
				<<endl;
				
		}
	}
	
	tauk_b = tmp_tk*1.5;
	if (tauk_b > 0.9)
	{
		tauk_b = 0.9;
	}
	Ntauk = (int)(tauk_b / tau_step);	
	
	cout<<tauk_b<<" "<<Ntauk<<endl;
}

//simulation:
void input_rnd( )  // 
{
        int k;
		string txt;
        ifstream fp("rnd.dat");
		
        for (k=0;k<N_rnd;k++) {
				double debug;
				fp>>debug;
				rnd_vec[k] = debug;
		} 
        fp.close();        
}

//compute the initial value of policy and value functions. finite horizon.
double f_m_k_brent_initial (DP x)
{
	double x_la;   
	
	double x_w0, x_r0, x_c0, x_euc, x_ul;
	double tmp_c0;
	x_la = x;
	x_w0 = a0_in*(1.0-theta)*pow(k0_in/x_la, theta);
	x_r0 = a0_in*theta*pow(k0_in/x_la, theta-1.0);

	x_c0 = alpha_c/(1.0-alpha_c)*(1.0-taul0_in)*x_w0*(1.0-x_la);
	
	tauk0_in = alpha_p/(1.0-alpha_p)/alpha_c * x_c0/(x_r0-delta)/k0_in;

	tmp_c0 = (1.0-tauk0_in)*x_r0*k0_in + (1.0-delta)*k0_in + ind_delta*tauk0_in*delta*k0_in + (1.0-taul0_in)*x_w0*x_la;
	
	return fabs(x_c0 / tmp_c0 - 1.0); // * (1.0- x_c0 * beta*x_euc);// + pent;
} 

void policy_initial()
{
	ofstream file("policy_mpe_initial.txt");
	
	for (int i_shk=0; i_shk<N_shk; i_shk++){	
		for (int i_k=0; i_k<Nk; i_k++){
		
			k0_in = k_vec[i_k];
			taul0_in = 0.0;
			
			if (i_shk == 0){
				a0_in = a_l;
			}
			if (i_shk == 1){
				a0_in = a_h;
			}	
			
			double x_w0, x_r0, x_c0, x_u0, x_g, x_ug;
			double x_k1, x_la;
			
			double tmp_a, tmp_y;
			tmp_a = alpha_p/( alpha_p+(1.0-alpha_p)*alpha_c);
			tauk0_in = tmp_a /theta;
			x_la = (1.0-theta) / (1.0-theta + tmp_a* (1.0-alpha_p)*(1.0-alpha_c)/alpha_p );

			x_w0 = a0_in*(1.0-theta)*pow(k0_in/x_la, theta);
			x_r0 = a0_in*theta*pow(k0_in/x_la, theta-1.0);
			tmp_y = a0_in*pow(k0_in, theta)*pow(x_la,1.0-theta);
			
			x_c0 = (1.0-tmp_a) * tmp_y;
			//alpha_c/(1.0-alpha_c)*(1.0-taul0_in)*x_w0*(1.0-x_la);
			x_k1 = 0.0;			
			
			x_g = tmp_a * tmp_y;
			
			x_u0 = (1.0-beta)* ( (1.0-alpha_p)*alpha_c*log(x_c0) + (1.0-alpha_p)*(1.0-alpha_c)*log(1.0-x_la) );
			x_ug = (1.0-beta)*alpha_p*log(x_g);
			
			policy_k1_1[i_k][i_shk] = x_k1;
			policy_l_1[i_k][i_shk] = x_la;
			policy_c_1[i_k][i_shk] = x_c0;
			policy_tk_1[i_k][i_shk] = tauk0_in;
			policy_tl_1[i_k][i_shk] = taul0_in;
			v1[i_k][i_shk] = x_u0 + x_ug;
		}
	}	
	print_policy();
}

int main(void)
{
	ofstream fout;
	fout.open("mpe_2013.txt");
	fout.setf(ios::fixed);
	fout.precision(10);
	time_t start,end;
    time (&start);

	//set grid points.
	kl = 0.01;
	kh = 1.50;
	taul_b = 0.0;
	tauk_a = 0.010;
	taul_a = 0.0;
	
	for (int i_k=0; i_k<Nk; i_k++){
		k_vec[i_k] = (kh-kl)/(Nk-1)*i_k+kl;  
	} 
	
	a_vec[0] = a_l;
	a_vec[1] = a_h;

	pi[0][0] = 0.946;
    pi[0][1] = 0.054;

	pi[1][0] = 0.054;
    pi[1][1] = 0.946;
	
	//policy_input1();
	//print_policy();
	policy_initial();

	delta = 1.0;
	N_d = 20;
	ind_delta = 0.0;
	double delta_a, delta_b, alpha_a, alpha_b;
	delta_a = .08;
	delta_b = 1.0;
	
	alpha_a = 0.0065;
	alpha_b = 0.08;
	int N_p = 20;	
	
	//+++++++++++++++++++++++++++++++++
	alpha_p = 0.0065;	
		
	for (int i_d = 0; i_d < N_d; i_d ++)
	{

		delta = (delta_a - delta_b) / (N_d - 1)*i_d + delta_b;
		
		do{
			//update the policy functions:
			for (int i_rho=0; i_rho<N_shk; i_rho++){	
				for (int i_k=0; i_k<Nk; i_k++){          
						
					policy_k1_0[i_k][i_rho] = policy_k1_1[i_k][i_rho];  
					policy_c_0[i_k][i_rho] = policy_c_1[i_k][i_rho];
					policy_l_0[i_k][i_rho] = policy_l_1[i_k][i_rho];
					policy_tk_0[i_k][i_rho] = policy_tk_1[i_k][i_rho];
					policy_tl_0[i_k][i_rho] = policy_tl_1[i_k][i_rho];
					v0[i_k][i_rho] = v1[i_k][i_rho];

				}

			}

			policy_eul_compute();

			cout<<"***********"<<endl;
			print_policy();

		}while (!check_euler());
		
		cout<<delta<<" "<<alpha_p<<endl;
	
	}//end delta
	
	ind_delta = 1.0;
	
	for (int i_d = 0; i_d < N_p; i_d ++)
	{	
		alpha_p = (alpha_b - alpha_a) / (N_p - 1)*i_d + alpha_a;	
				
		do{
			//update the policy functions:
			for (int i_rho=0; i_rho<N_shk; i_rho++){	
				for (int i_k=0; i_k<Nk; i_k++){          
						
					policy_k1_0[i_k][i_rho] = policy_k1_1[i_k][i_rho];  
					policy_c_0[i_k][i_rho] = policy_c_1[i_k][i_rho];
					policy_l_0[i_k][i_rho] = policy_l_1[i_k][i_rho];
					policy_tk_0[i_k][i_rho] = policy_tk_1[i_k][i_rho];
					policy_tl_0[i_k][i_rho] = policy_tl_1[i_k][i_rho];
					v0[i_k][i_rho] = v1[i_k][i_rho];
				}
				
			}

			policy_eul_compute();

			cout<<"***********"<<endl;
			print_policy();
			
		}while (!check_euler());
		
		cout<<"alpha: "<<alpha_p<<" +++++++++++++++++++"<<endl;
	
	}//end alpha_p
		
	//step #: report the running time.
	time (&end);
	DP  dif = difftime (end,start);
    fout<<"Running time: "<< dif/60 <<" minutes."<< endl;

	return 0;
}
