//#include <omp.h>
#include <iostream>
#include <fstream>
#include <iomanip>
#include <cmath>
#include "nr.h"
#include <vector>
#include <stdio.h> 
#include <time.h>
using namespace std;
# include "minpack.H"
# include "asa047.H"

double beta = 0.96;
double theta = 0.36;
double delta = 0.08;
double alpha_p = 0.13;
double alpha_c = 0.30;
double a_h = 1.024;
double a_l = 0.976;
double a0, a0_in;
double p11, p12, p21, p22;
double pi_1, pi_2;

double tau_k, tau_l;
double tau_k_in, tau_l_in;
const int Ntau = 200;
double tau_vec[Ntau];
double tau_a = 0.001; 
double tau_b = 0.9;   //boundary of tax rate.

const int Nk = 400; //200;
const int Ns = 2;
const int Nbdr = 2;
const int Nm = 50;
const int Nm_search = 1000;
//const int Nv = 500;

double kl = 0.01;
double kh = 1.50;
double k0, k0_in, k1;
double k_vec[Nk];
double Wm_0[Nk][Ns][Nbdr];   //ind. payoff
double Wv0_0[Nk][Ns][Nm];             //lower bound of govt. payoff    
double Wv_0[Nk][Ns][Nm];       //upper bound of govt. payoff  
double gv0[Nk][Ns];
double W_pent[Nk][Ns];
double m0_in;
double m0, m1;
double check_m, check_v;
double check_vec[2];
double gk1[Nk][Ns], gtauk[Nk][Ns], gtaul[Nk][Ns];
double gc[Nk][Ns], gl[Nk][Ns];

double out_m_k[8];  //k1, l, uc, u, ff, c0

//update v:
int vl_shk;
double vl_k0, vh_k1, vh_v0;
double m1_s1_l[Nm], m1_s1_r[Nm];
double m1_s2_l[Nm], m1_s2_r[Nm];

double tol_Wm = 1e-4;  //1e-8; 
double tol_Wv = 1e-4; 
double tol_eul = 1.0*1e-3;  
double tol_f_mk = 1e-10;
double tol_v0 = 1e-3;

double max_dis_m, max_dis_vl, max_dis_vh;   
const int N_rnd = 1000;
double rnd_vec[N_rnd];   
double dist_v0_sim;

//***********************************************************

void NRlocate(double xx[], int size, double x, int &j)
{
	int ju,jm,jl;
	bool ascnd;

	int n=size;
	jl=-1;
	ju=n;
	ascnd=(xx[n-1] >= xx[0]);
	while (ju-jl > 1) {
		jm=(ju+jl) >> 1;
		if (x >= xx[jm] == ascnd)
			jl=jm;
		else
			ju=jm;
	}
	if (x == xx[0]) j=0;
	else if (x == xx[n-1]) j=n-2;
	else j=jl;
}

void shock(int &shk, double x_a, double &x_p1, double &x_p2)
{
	if (shk == 0) {
		x_a = a_l;
		x_p1 = p11;
		x_p2 = p12;
	}
	else if (shk == 1) {
		x_a = a_h;
		x_p1 = p21;
		x_p2 = p22;
	}
}
   
void input_rnd( )  // import the pi matrix.
{
        int k;
		string txt;
        ifstream fp("rnd.dat");
		
        for (k=0;k<N_rnd;k++) {
				double debug;
				fp>>debug;
				rnd_vec[k] = debug;
		} 
        fp.close();        
}

double intp_1d(double &x_k, int &shk, double policy[Nk][Ns])
{   
	int i_k;	
	NRlocate(k_vec, Nk, x_k, i_k);
    if (i_k==-1){i_k = 0;}
	if (i_k==Nk-1){i_k = Nk-2;}
		
	return policy[i_k][shk] + (policy[i_k+1][shk]-policy[i_k][shk])
		/(k_vec[i_k+1] - k_vec[i_k])*(x_k - k_vec[i_k]);	
} 

void input_Wm( )
{  
	string txt;
    ifstream fp("policy_mpe_output.txt");
	
	for (int i_s = 0; i_s < Ns; i_s++) {
		for (int row = 0; row < Nk; row ++) {
				
				double dg1, dg2, dg3, dg4, dg5, dg6, dg7; 
				fp>>dg1>>dg2>>dg3>>dg4>>dg5>>dg6>>dg7;   
                         
				
				k_vec[row] = dg1;
				gk1[row][i_s] = dg2;
				gl[row][i_s] = dg3;
				gc[row][i_s] = dg4;
				gtauk[row][i_s] = dg5;	
				gtaul[row][i_s] = dg6;
				gv0[row][i_s] = dg7;
				
		}
	}
}
 
int main(int argc, char** argv)
{
      ofstream fout;
      fout.open("game_sto_sim_mpe_2013.txt");
      fout.setf(ios::fixed);
      fout.precision(6);

	  p11 = 0.946;
	  p12 = 0.054;
	  p21 = 0.054;
      p22 = 0.946;
   
		//***********************************************************//
		for (int row = 0; row < Nk; row++) {
            k_vec[row] = (kh-kl)/(Nk-1)*(row)+kl;
		}

		for (int row = 0; row < Ntau; row++) {
            tau_vec[row] = (tau_b-tau_a)/(Ntau-1)*(row)+tau_a;
		}

		input_rnd( );
		input_Wm( ); 
		//input_Wm( ); 
				
		//simulation: 
		int N_sim = 1;
		int Nt = 1000;
		double k0_sim, k1_sim, m0_sim, m1_sim, v0_sim, v1_sim; 

		double k1_sim1, k1_sim2;
		double tau_k_sim1, tau_l_sim1;
		double tau_k_sim2, tau_l_sim2;
		double m11_sim1, m12_sim1, v11_sim1, v12_sim1; 
		double m11_sim2, m12_sim2, v11_sim2, v12_sim2; 

		double l_sim, c_sim, y_sim, g_sim; 
		double l_sim1, c_sim1, y_sim1, g_sim1;
		
		double tau_k_sim, tau_l_sim;
		int i_s, shk0_sim, shk1_sim; 
		double tmp_v0_max, tmp_dist_min1, tmp_dist_min2;  
		
		//*************
		double x_k1, x_l, x_m11, x_m12;
		double tmp_m1_l, tmp_m1_r;
		int lef;     
		double m1_vec_l[Nm], m1_vec_r[Nm];  
		double ev1, ev0; 
		double ev1_1, ev1_2;

		int x_shk1;
		double x_v11, x_v12;
		double tfp;
		
		                        
		// Wm_0[row][i_s][0]
		    
		//initial condition. 
		    k1_sim = 0.607;
			shk1_sim = 0;
			
			for (int t = 0; t < Nt; t++){  
				
				k0_sim = k1_sim; 
				shk0_sim = shk1_sim;
				
				tau_k_sim = intp_1d(k0_sim, shk0_sim, gtauk);
				tau_l_sim = intp_1d(k0_sim, shk0_sim, gtaul);
				k1_sim = intp_1d(k0_sim, shk0_sim, gk1);
				c_sim = intp_1d(k0_sim, shk0_sim, gc);
				l_sim = intp_1d(k0_sim, shk0_sim, gl);

				v0_sim = intp_1d(k0_sim, shk0_sim, gv0);				
   			 
				//determine shk1.
				if (shk0_sim == 0){              
					if (rnd_vec[t] <= p11){
						shk1_sim = 0;  
					}                   
					if (rnd_vec[t] > p11){
						shk1_sim = 1; 
					}
				} 
				if (shk0_sim == 1){              
					if (rnd_vec[t] <= p21){
						shk1_sim = 0; 
					}                   
					if (rnd_vec[t] > p21){
						shk1_sim = 1;
					}
				} 
				//end: shk1
				
				if (shk0_sim == 1){
					tfp = 1.0 + 0.024;
				}
				if (shk0_sim == 0){
					tfp = 1.0 - 0.024;
				}
				
				double tmp_r, tmp_w;
				tmp_r = tfp*theta*pow(k0_sim/l_sim, theta-1.0);
				tmp_w = tfp*(1.0-theta)*pow(k0_sim/l_sim, theta);
				g_sim = tfp*(tmp_r-delta)*tau_k_sim + tau_l_sim*tmp_w*l_sim;
				
				if (t>=500){
					fout<<tfp<<" "<<k0_sim<<" "<<c_sim<<" "<<k1_sim<<" "<<l_sim<<" "<<g_sim<<" "
						<<tau_k_sim<<" "<<tau_l_sim<<" "<<v0_sim<<endl; 
				}
				 
			
			}  //t    
		return 0;
}  
