#include <iostream>
#include <iostream>
#include <iomanip>
#include <cmath>
#include "nr.h"
#include <vector>
#include <stdio.h> 
#include <time.h>
#include <math.h>

#include <stdlib.h>
#include <assert.h>
#include <stdio.h>
# include "asa047.H"
# include "minpack.H"

using namespace std;

//***********//
//parameters:
//***********//
double beta = 0.96;
double alpha = 0.36; //theta, capital share
double delta = 0.08;
double alpha_p = 0.13;
double alpha_c = 0.30;
double a_h = 1.024;
double a_l = 0.976;    
double a0, a0_in;
double p11, p12, p21, p22;
double pi_1, pi_2;    

const int Nk=100; //15
const int N_lag=100;   //lagrange multiplier

double kl, kh, lagl, lagh;
double k0, k0_in, k1; 
double lag0, lag1;
double k_vec[Nk], lag_vec[N_lag];
 
//shocks:      
const int N_shk = 2;
int shk0, shk1;     
double pi[N_shk][N_shk];
double a_vec[N_shk];

double policy_c_0[Nk][N_lag][N_shk], policy_l_0[Nk][N_lag][N_shk], policy_k1_0[Nk][N_lag][N_shk], policy_lag_0[Nk][N_lag][N_shk]; 
double policy_c_1[Nk][N_lag][N_shk], policy_l_1[Nk][N_lag][N_shk], policy_k1_1[Nk][N_lag][N_shk], policy_lag_1[Nk][N_lag][N_shk];
         
double tol_eul = 1e-6;

const int N_rnd = 1000;
double rnd_vec[N_rnd];

int shk_ini;
double k0_ini, tk_ini;

void policy_input0()  // import the initial policy functions.
{
        //int k,l;
		string txt;
        ifstream fp("policy_functions_4_0.txt");

		
		for (int i_rho=0; i_rho<N_shk; i_rho++){	
			for (int i_k=0; i_k<Nk; i_k++){   
				//for (int i_l=0; i_l<N_lag; i_l++){ 
				for (int i_l=0; i_l<1; i_l++){   
				
					double debug0, debug1, debug2, debug3, debug4, debug5, debug6;
					
					fp>>debug1>>debug2>>debug3>>debug4>>debug5>>debug6;

					if (debug3 <= kl){
						debug3 = kl;
					}
					if (debug3 >= kh){
						debug3 = kh;
					}

					if (debug4 <= lagl){
						debug4 = lagl;
					}
					if (debug4 >= lagh){
						debug4 = lagh;
					}

					if (debug6 <= 0.0l){
						debug6 = 0.01;
					}
					if (debug6 >= 0.99){
						debug6 = 0.99;
					}

					policy_k1_1[i_k][i_l][i_rho] = debug3 + 0.4;
				
				}
			}
		} 

		for (int i_rho=0; i_rho<N_shk; i_rho++){	
			for (int i_k=0; i_k<Nk; i_k++){   
				for (int i_l=1; i_l<N_lag; i_l++){ 
				
					policy_k1_1[i_k][i_l][i_rho] = policy_k1_1[i_k][0][i_rho];
				}
			}
		}  

       fp.close();        
}

void policy_input1()  // import the initial policy functions.
{
        //int k,l;
		string txt;
        ifstream fp("policy_functions_7.txt");

		
		for (int i_rho=0; i_rho<N_shk; i_rho++){	
			for (int i_k=0; i_k<Nk; i_k++){   
				for (int i_l=0; i_l<N_lag; i_l++){ 
					double debug0, debug1, debug2, debug3, debug4, debug5, debug6;
					
					fp>>debug1>>debug2>>debug3>>debug4>>debug5>>debug6;

					policy_k1_1[i_k][i_l][i_rho] = debug3;
					policy_lag_1[i_k][i_l][i_rho] = debug4;
					policy_c_1[i_k][i_l][i_rho] = debug5;
					policy_l_1[i_k][i_l][i_rho] = debug6;
				
				}
			}
		} 

       fp.close();        
}

void policy_input2()  // import the initial policy functions.
{
        //int k,l;
		string txt;
        ifstream fp("policy_functions_5_2-6.txt");

		
		for (int i_rho=0; i_rho<N_shk; i_rho++){	
			for (int i_k=0; i_k<Nk; i_k++){   
				for (int i_l=0; i_l<N_lag; i_l++){ 
					double debug0, debug1, debug2, debug3, debug4, debug5, debug6;
					
					fp>>debug1>>debug2>>debug3>>debug4>>debug5>>debug6;

					policy_k1_1[i_k][i_l][i_rho] = debug3;
				
				}
			}
		} 

       fp.close();        
}

bool check_euler() //covergence tolerance.
{
		bool ans = true;
		for (int i_rho=0; i_rho<N_shk; i_rho++){	
			for (int i_k=0; i_k<Nk; i_k++){   
				for (int i_l=0; i_l<N_lag; i_l++){
					if (fabs(policy_k1_1[i_k][i_l][i_rho]-policy_k1_0[i_k][i_l][i_rho])>tol_eul ||  
					    fabs(policy_lag_1[i_k][i_l][i_rho]-policy_lag_0[i_k][i_l][i_rho])>tol_eul ||    
						fabs(policy_c_1[i_k][i_l][i_rho]-policy_c_0[i_k][i_l][i_rho])>tol_eul ||
						fabs(policy_l_1[i_k][i_l][i_rho]-policy_l_0[i_k][i_l][i_rho])>tol_eul ) {
						return false;
					}  
				}
			}
		}
	return ans;
}

void NRlocate(double xx[], int size, double x, int &j)
{
	int ju,jm,jl;
	bool ascnd;

	int n=size;
	jl=-1;
	ju=n;
	ascnd=(xx[n-1] >= xx[0]);
	while (ju-jl > 1) {
		jm=(ju+jl) >> 1;
		if (x >= xx[jm] == ascnd)
			jl=jm;
		else
			ju=jm;
	}
	if (x == xx[0]) j=0;
	else if (x == xx[n-1]) j=n-2;
	else j=jl;
}

double intp(double &x_k0, double &x_lag0, int &shk, double policy[Nk][N_lag][N_shk])
{   
	int i_k, i_lag;
	double intp_k0, intp_lag0;
	NRlocate(k_vec, Nk, x_k0, i_k);
    	NRlocate(lag_vec, N_lag, x_lag0, i_lag);
	if (i_k==-1){i_k = 0;}
	if (i_lag==-1){i_lag = 0;}
	if (i_k==Nk-1){i_k = Nk-2;}
	if (i_lag==N_lag-1){i_lag = N_lag-2;}
    intp_k0 = (x_k0-k_vec[i_k])/(k_vec[i_k+1]-k_vec[i_k]);
	intp_lag0 = (x_lag0-lag_vec[i_lag])/(lag_vec[i_lag+1]-lag_vec[i_lag]);
	
	//***********************************//
	double tmp = (1.0-intp_k0)*(1-intp_lag0)*policy[i_k][i_lag][shk]
		+ intp_k0*(1-intp_lag0)*policy[i_k+1][i_lag][shk]
		+ intp_k0*intp_lag0*policy[i_k+1][i_lag+1][shk] 
		+ (1.0-intp_k0)*intp_lag0*policy[i_k][i_lag+1][shk];
		
	return tmp;	
}
      
//**************************************************************************
double next_uc(int &shk1_i, double &k1_i, double &lag0_i)
//get u'(c+) 
{
	double lag1_i, c1_i, l1_i, k2_i;
	
	l1_i = intp(k1_i, lag0_i, shk1_i, policy_l_0); 
	k2_i = intp(k1_i, lag0_i, shk1_i, policy_k1_0);
	c1_i = intp(k1_i, lag0_i, shk1_i, policy_c_0);
    
	double w1_i, g1_i, tmp_f1, tmp_f2, tmp_f3;

	w1_i = a_vec[shk1_i]*(1.0-alpha)*pow(k1_i/l1_i,alpha);

	g1_i = a_vec[shk1_i]*pow(k1_i,alpha)*pow(l1_i,1.0-alpha) + (1.0-delta)*k1_i - c1_i - k2_i; 

	double tmp1, tmp2;
	tmp1 = alpha_c / c1_i * (c1_i+k2_i); 
	tmp2 = -(1.0-alpha_c) / (1.0-l1_i) * l1_i;

	//cout<<tmp1<<" "<<tmp2<<" "<<c1_i<<" "<<k1_i<<" "<<lag0_i<<" "<<k2_i<<endl<<endl;
	return tmp1 + tmp2;
}

double expt_uc(int &shk0_i, double &k1_i, double &lag0_i)
//get the E(u'(c+))
{
	double e_uc = 0.0;

	for (int i_shk0=0; i_shk0<N_shk; i_shk0++){	
		if (i_shk0 == shk0_i){
			for (int i_shk1=0; i_shk1<N_shk; i_shk1++){	
				e_uc += pi[i_shk0][i_shk1]*next_uc(i_shk1, k1_i, lag0_i);    
				//cout<<e_uc<<endl;
			}
		}
	}
	return e_uc;
}  
//************************************************************************** 
   
//**************************************************************************
double next_ug(int &shk1_i, double &k1_i, double &lag0_i)
//get u'(g+) 
{
	//ofstream file("eug.txt");
	//file.precision(4);

	double lag1_i, c1_i, l1_i, k2_i;  
	double g1_i, r1_i;
	
	k2_i = intp(k1_i, lag0_i, shk1_i, policy_k1_0);  
	l1_i = intp(k1_i, lag0_i, shk1_i, policy_l_0);
	c1_i = intp(k1_i, lag0_i, shk1_i, policy_c_0);
	
	r1_i = a_vec[shk1_i]*alpha*pow(k1_i/l1_i,alpha) / (k1_i/l1_i);
	
	double w1_i, tmp_f1, tmp_f2, tmp_f3;

	w1_i = a_vec[shk1_i]*(1.0-alpha)*pow(k1_i/l1_i,alpha);

	g1_i = a_vec[shk1_i]*pow(k1_i,alpha)*pow(l1_i,1.0-alpha) + (1.0-delta)*k1_i - c1_i - k2_i;  

	double tmp1, tmp2;
	tmp1 = (r1_i+1.0-delta)*alpha_p/g1_i;
	return tmp1; // + tmp2;
}

double expt_ug(int &shk0_i, double &k1_i, double &lag0_i)
//get the E(u'(g+))
{
	double e_ug = 0.0;

	for (int i_shk0=0; i_shk0<N_shk; i_shk0++){	
		if (i_shk0 == shk0_i){
			for (int i_shk1=0; i_shk1<N_shk; i_shk1++){	
				e_ug += pi[i_shk0][i_shk1]*next_ug(i_shk1, k1_i, lag0_i);    
			}
		}
	}
	return e_ug;
}  
//**************************************************************************
   
void eul_f ( int n, double x[], double fvec[], int *iflag )
{
	double pent = 0.0;
	double lr0, c0, g0, w0;
	k1 = x[0];       
	lr0 = x[1]; 
	c0 = x[2];
	lag1 = x[3];

	if (k1 <= kl){
		x[0] = kl;
		pent += 100*fabs(k1-kl);
		k1 = x[0];
	}
	if (k1 >= a_vec[shk0]*pow(k0,alpha)*pow(lr0,1.0-alpha) + (1.0-delta)*k0 ){
		x[0] = a_vec[shk0]*pow(k0,alpha)*pow(lr0,1.0-alpha) + (1.0-delta)*k0 - 0.001;
		pent += 100*fabs( k1 - (a_vec[shk0]*pow(k0,alpha)*pow(lr0,1.0-alpha) + (1.0-delta)*k0) );
		k1 = x[0];
	}

	if (lr0 < 0.05){
		x[1] = 0.02;
		pent += 100*fabs(lr0-0.02);
		lr0 = x[1]; 
	}
	if (lr0 > 0.9){
		x[1] = 0.9;
		pent += 100*fabs(lr0-0.9);
		lr0 = x[1]; 
	}

	w0 = a_vec[shk0]*(1.0-alpha)*pow(k0/lr0,alpha);   

	if (c0 <= 0.0001){
		x[2] = 0.001;
		pent += 100*fabs(c0-0.0001);
		c0 = x[2];
	}
	if (c0 > a_vec[shk0]*pow(k0,alpha)*pow(lr0,1.0-alpha) + (1.0-delta)*k0 - k1){
		x[2] = a_vec[shk0]*pow(k0,alpha)*pow(lr0,1.0-alpha) + (1.0-delta)*k0 - k1 - 0.0001;
		pent += 100*fabs( c0 - (a_vec[shk0]*pow(k0,alpha)*pow(lr0,1.0-alpha) + (1.0-delta)*k0 - k1) );
		c0 = x[2];
	}

	if (lag1 <= lagl){
		x[3] = lagl;
		pent += 100*fabs(lag1-lagl);
		lag1 = x[3];
	}
	if (lag1 >= lagh){
		x[3] = lagh;
		pent += 100*fabs(lag1-lagh);
		lag1 = x[3];
	}

	double tmp_f1, tmp_f2, tmp_f3;

	g0 = a_vec[shk0]*pow(k0,alpha)*pow(lr0,1.0-alpha) + (1.0-delta)*k0 - c0 - k1; 

	if (g0 <= 0.0001){
		g0 = 0.0001;
		pent += 1000*fabs(g0-0.0001);
	}

	tmp_f1 = (1.0-alpha_p)*alpha_c*c0 *g0;
	tmp_f2 = (1.0-alpha_p)*alpha_c;
	tmp_f3 = alpha_p*c0*c0;

	//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
	double uc0_s, ul0_s, tl0_s, tk0_s, r0;

	r0 = a_vec[shk0]*alpha*pow(k0/lr0,alpha-1.0);  

	uc0_s = (1.0-alpha_p)*alpha_c/c0;
	ul0_s = -(1.0-alpha_p)*(1.0-alpha_c)/(1.0-lr0);
				
	tl0_s = 1.0-(-ul0_s)/uc0_s/w0;
	tk0_s = (g0-tl0_s*w0*lr0) / (r0-delta)/k0;

	if (tl0_s < 0.0){
		pent += 1000*fabs(tl0_s-0.0);
	}
	if (tk0_s < 0.0){
		pent += 1000*fabs(tk0_s-0.0);
	}
	//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
	

	fvec[3] = fabs( lag1 *g0 *k1 - ((tmp_f3-tmp_f1) / tmp_f2 + lag0 *g0 *k1) ) + pent;

	double tmp_euc, tmp_eug;
	tmp_euc = expt_uc(shk0, k1, lag1); 
	tmp_eug = expt_ug(shk0, k1, lag1);  
	
	double tmp_ug;
	tmp_ug = (lag1-lag0)*(1.0-alpha_p)*alpha_c;
	
	fvec[0] = fabs(alpha_p *c0 - tmp_ug *g0  - beta*tmp_eug *g0 *c0) + pent;	
	fvec[1] = fabs(alpha_c * k1 - beta*tmp_euc *c0) + pent;

	double tmp_f3_1, tmp_f3_2, tmp_f3_3, tmp_f3_4;

	tmp_f3_1 = (1.0-alpha_p)*(1.0-alpha_c) * g0 * (1.0-lr0 + lag0);
	tmp_f3_2 = alpha_p*w0 *(1.0-lr0)*(1.0-lr0);
	
	fvec[2] = fabs(tmp_f3_1 - tmp_f3_2) + pent;
}

void policy_eul_compute()
{
	//static 
	ofstream file("policy_functions_8_ini.txt");
	file.precision(4);

	for (int i_shk=0; i_shk<N_shk; i_shk++){	
		for (int i_k=0; i_k<Nk; i_k++){
			for (int i_lag=0; i_lag<N_lag; i_lag++){
			
			    k0 = k_vec[i_k];
				shk0 = i_shk;  
				lag0 = lag_vec[i_lag];
				
			    double *fvec;
				int iflag;
				int info;
				int lwa;
				int n = 4;
				double tol = 1e-16;
				double *wa;
	            double *xx;

				lwa = ( n * ( 3 * n + 13 ) ) / 2;
				fvec = new double[n];
				wa = new double[lwa];
				xx = new double[n];

				xx[0] = policy_k1_0[i_k][i_lag][i_shk];
				xx[1] = policy_l_0[i_k][i_lag][i_shk];
				xx[2] = policy_c_0[i_k][i_lag][i_shk];
				xx[3] = policy_lag_0[i_k][i_lag][i_shk];
    			
				//r8vec_print ( n, x, "  Initial X" );
				iflag = 1;
				eul_f ( n, xx, fvec, &iflag );
				//r8vec_print ( n, fvec, "  F(X)" );

				info = hybrd1 ( eul_f, n, xx, fvec, tol, wa, lwa );
			
				policy_k1_1[i_k][i_lag][i_shk] = xx[0];
				policy_l_1[i_k][i_lag][i_shk] = xx[1];
				policy_c_1[i_k][i_lag][i_shk] = xx[2];
				policy_lag_1[i_k][i_lag][i_shk] = xx[3];
				     
				delete [] fvec;
				delete [] wa;
				delete [] xx;  		  
				

				file<<k0<<" "<<lag0<<" "
				 <<policy_k1_1[i_k][i_lag][i_shk]<<" "
				 <<policy_lag_1[i_k][i_lag][i_shk]<<" "
				 <<policy_c_1[i_k][i_lag][i_shk]<<" "
				 <<policy_l_1[i_k][i_lag][i_shk]<<" "    
				 <<endl;        
			}
		}
	}
}

//simulation:
void input_rnd( )  // 
{
        int k;
		string txt;
        ifstream fp("rnd.dat");
		
        for (k=0;k<N_rnd;k++) {
				double debug;
				fp>>debug;
				rnd_vec[k] = debug;
		} 
        fp.close();        
}


//**************************************************************************
     
void eul_ini ( int n, double x[], double fvec[], int *iflag )
{
	double pent = 0.0;
	double lr0, c0, g0, w0, r0;
	k1 = x[0];       
	lr0 = x[1]; 
	c0 = x[2];
	lag1 = x[3];

	if (k1 <= kl){
		x[0] = kl;
		pent += 100*fabs(k1-kl);
		k1 = x[0];
	}
	if (k1 >= a_vec[shk_ini]*pow(k0_ini,alpha)*pow(lr0,1.0-alpha) + (1.0-delta)*k0_ini ){
		x[0] = a_vec[shk_ini]*pow(k0_ini,alpha)*pow(lr0,1.0-alpha) + (1.0-delta)*k0_ini - 0.001;
		pent += 100*fabs( k1 - (a_vec[shk_ini]*pow(k0_ini,alpha)*pow(lr0,1.0-alpha) + (1.0-delta)*k0_ini) );
		k1 = x[0];
	}

	if (lr0 < 0.05){
		x[1] = 0.05;
		pent += 100*fabs(lr0-0.05);
		lr0 = x[1]; 
	}
	if (lr0 > 0.9){
		x[1] = 0.9;
		pent += 100*fabs(lr0-0.9);
		lr0 = x[1]; 
	}

	w0 = a_vec[shk_ini]*(1.0-alpha)*pow(k0_ini/lr0,alpha);  
	r0 = a_vec[shk_ini]*(alpha)*pow(k0_ini/lr0,alpha-1.0);   

	if (c0 <= 0.0001){
		x[2] = 0.0001;
		pent += 100*fabs(c0-0.0001);
		c0 = x[2];
	}
	if (c0 > a_vec[shk_ini]*pow(k0_ini,alpha)*pow(lr0,1.0-alpha) + (1.0-delta)*k0_ini - k1){
		x[2] = a_vec[shk_ini]*pow(k0_ini,alpha)*pow(lr0,1.0-alpha) + (1.0-delta)*k0_ini - k1 - 0.0001;
		pent += 100*fabs( c0 - (a_vec[shk_ini]*pow(k0_ini,alpha)*pow(lr0,1.0-alpha) + (1.0-delta)*k0_ini - k1) );
		c0 = x[2];
	}

	if (lag1 <= lagl){
		x[3] = lagl;
		pent += 100*fabs(lag1-lagl);
		lag1 = x[3];
	}
	
	if (lag1 >= lagh){
		x[3] = lagh;
		pent += 100*fabs(lag1-lagh);
		lag1 = x[3];
	}

	double uc0, ul0;
	uc0 = alpha_c/c0;
	ul0 = -(1.0-alpha_c)/(1.0-lr0);
	g0 = (w0+ul0/uc0)*lr0 + tk_ini*(r0-delta)*k0_ini;

	if (g0 <= 0.001){
		g0 = 0.001;
		pent += 1000*fabs(g0-0.001);
	}

//*******************************
	double tmp_euc, tmp_eug;
	tmp_euc = expt_uc(shk_ini, k1, lag1); 
	tmp_eug = expt_ug(shk_ini, k1, lag1);  

	fvec[0] = fabs(alpha_c*k1  - beta*tmp_euc *c0) + pent;	
	fvec[1] = fabs(lag1*(1.0-alpha_p)*alpha_c - beta*tmp_eug *c0) + pent;

//*******************************
	double tmp_f1, tmp_f2, tmp_f3, tmp_f4;
	tmp_f1 = alpha_p*(1.0-alpha_c) / (1.0-alpha_p) / alpha_c /alpha_c;
	tmp_f2 = lr0*c0*c0;

	fvec[2] = fabs( c0 *g0*(1.0-lr0) + lag1*k1 *g0*(1.0-lr0) - tmp_f1*tmp_f2 ) + pent;

//*******************************
	double fll, fkl;
	fll = a_vec[shk_ini]*(1.0-alpha)*(-alpha)*pow(k0_ini/lr0,alpha) / lr0 ;
	fkl = a_vec[shk_ini]*(1.0-alpha)*(alpha)*pow(k0_ini/lr0,alpha-1.0) / lr0 ;

	tmp_f1 = -(1.0-alpha_p)*(1.0-alpha_c) *(1.0-lr0)*g0;
	tmp_f2 = (1.0-alpha_c)/alpha_c *(-c0) *(1.0-lr0);
 	tmp_f3 = ( fll *(1.0-lr0)*(1.0-lr0) + (1.0-alpha_c)/alpha_c *(-c0) ) * lr0;
	tmp_f4 = tk_ini*k0_ini*fkl* (1.0-lr0)*(1.0-lr0);

	fvec[3] = fabs( tmp_f1 *g0 + alpha_p * (w0 *(1.0-lr0)*(1.0-lr0) + tmp_f2 + tmp_f3 + tmp_f4) ) + pent;

	cout<<fvec[0]<<" "<<fvec[1]<<" "<<fvec[2]<<" "<<fvec[3]<<" "<<endl;

//*******************************
}

void simulation()
{
	ofstream file("simulation_ramsey.txt");
	file.precision(4);

	int Nt = 1000; //N_rnd;
	double c0_s, l0_s, g0_s, k0_s, k1_s, lag0_s, lag1_s, y0_s;
	int shk0_s, shk1_s;
	double tk0_s, tl0_s;
	double uc0_s, ul0_s, w0_s, r0_s;

	double total_u, tmp_u, dist;

	input_rnd( );

	//initial cond. 
	k1_s = 1.327; 
	lag1_s = 0.0;
	shk1_s = 1;

	total_u = 0.0;
       dist = 0.0;

	int N_sim = 2;
	for (int i_sim = 0; i_sim<N_sim; i_sim++){ //each simulation start with different tk_0

		k1_s = 1.327; 
		lag1_s = 0.0;
		shk1_s = 0;

		for (int t=0; t<Nt; t++){
			k0_s = k1_s;
			lag0_s = lag1_s;
			shk0_s = shk1_s;

			if (i_sim > 0 && t==0){
				tk0_s = (0.9-0.00)/(N_sim-1) * i_sim + 0.00;  //0.872894;

				shk_ini = shk0_s;
	 			k0_ini = k0_s;
				tk_ini = tk0_s;

				//***********************************************************
					double *fvec;
					int iflag;
					int info;
					int lwa;
					int n = 4;
					double tol = 1e-16;
					double *wa;
	            	double *xx;

					lwa = ( n * ( 3 * n + 13 ) ) / 2;
					fvec = new double[n];
					wa = new double[lwa];
					xx = new double[n];

					xx[0] = 1.368;
					xx[1] = 0.2498;
					xx[2] = 0.2210;
					xx[3] = 0.4976;
    			
					r8vec_print ( n, xx, "  Initial X" );
					iflag = 1;
					eul_ini ( n, xx, fvec, &iflag );
					r8vec_print ( n, fvec, "  F(X)" );

					info = hybrd1 ( eul_ini, n, xx, fvec, tol, wa, lwa );
				//***********************************************************
				k1_s = xx[0]; 
				l0_s = xx[1]; 
				c0_s = xx[2]; 
				lag1_s = xx[3];
 
				delete [] fvec;
				delete [] wa;
				delete [] xx; 

				y0_s = a_vec[shk0_s]*pow(k0_s,alpha)*pow(l0_s,1.0-alpha);  

				uc0_s = (1.0-alpha_p)*alpha_c/c0_s;
				ul0_s = -(1.0-alpha_p)*(1.0-alpha_c)/(1.0-l0_s);
				w0_s = a_vec[shk0_s]*(1.0-alpha)*pow(k0_s/l0_s,alpha);  
				r0_s = a_vec[shk0_s]*alpha*pow(k0_s/l0_s,alpha-1.0);

			
				tl0_s = 1.0-(-ul0_s)/uc0_s/w0_s;
				g0_s = (w0_s+ul0_s/uc0_s)*l0_s + tk0_s*(r0_s-delta)*k0_s;

				tmp_u = (1-alpha_p)*alpha_c*log(c0_s)+(1-alpha_p)*(1-alpha_c)*log(1.0-l0_s) + alpha_p*log(fabs(g0_s));
				//tmp_u = 0.0;

			}

			if (t>0 || i_sim == 0){

				if (t==0){
					lag0_s = 0.49;
				}
				c0_s = intp(k0_s, lag0_s, shk0_s, policy_c_1); 
				l0_s = intp(k0_s, lag0_s, shk0_s, policy_l_1); 
				k1_s = intp(k0_s, lag0_s, shk0_s, policy_k1_1); 
				lag1_s = intp(k0_s, lag0_s, shk0_s, policy_lag_1);
 
				y0_s = a_vec[shk0_s]*pow(k0_s,alpha)*pow(l0_s,1.0-alpha);  

				uc0_s = (1.0-alpha_p)*alpha_c/c0_s;
				ul0_s = -(1.0-alpha_p)*(1.0-alpha_c)/(1.0-l0_s);
				w0_s = a_vec[shk0_s]*(1.0-alpha)*pow(k0_s/l0_s,alpha);  
				r0_s = a_vec[shk0_s]*alpha*pow(k0_s/l0_s,alpha-1.0);

				tl0_s = 1.0-(-ul0_s)/uc0_s/w0_s;
				g0_s = y0_s+(1.0-delta)*k0_s-c0_s-k1_s;
				tk0_s = (g0_s-tl0_s*w0_s*l0_s) / (r0_s-delta)/k0_s;

				tmp_u = (1-alpha_p)*alpha_c*log(c0_s)+(1-alpha_p)*(1-alpha_c)*log(1.0-l0_s) + alpha_p*log(fabs(g0_s));

			}
		
			dist = t;
			total_u += pow(beta, dist-1) * (1.0-beta)*tmp_u;

			//shk:
			if (shk0_s == 0) {
				if (rnd_vec[t] <= pi[0][0]){
					shk1_s = 0;
				}
				if (rnd_vec[t] > pi[0][0]){
					shk1_s = 1;
				}
			}
			else if (shk0_s == 1) {
				if (rnd_vec[t] <= pi[1][0]){
					shk1_s = 0;
				}
				if (rnd_vec[t] > pi[1][0]){
					shk1_s = 1;
				}
			}
			file<<shk0_s<<" "<<k0_s<<" "<<l0_s<<" "<<y0_s<<" "<<k0_s/y0_s<<" "<<c0_s/y0_s<<" "<<g0_s/y0_s<<" "<<c0_s/g0_s<<" "<<
				tk0_s<<" "<<tl0_s<<" "<<lag0_s<<" "<<c0_s<<" "<<g0_s<<" "<<tmp_u<<endl;		

		}
		cout<<total_u<<endl;

		file<<"***********************************************************"<<endl;
	}
}

int main(void)
{
	ofstream fout;
	fout.open("benchmark_ramsey.txt");
	fout.setf(ios::fixed);
	fout.precision(10);
	time_t start,end;
    time (&start);

//set grid points.
	kl = 0.5;
	kh = 2.0;
	lagl = 0.00;
	lagh = 1.0;
	
	for (int i_k=0; i_k<Nk; i_k++){
		k_vec[i_k] = (kh-kl)/(Nk-1)*i_k+kl;  
	} 
	for (int i_lag=0; i_lag<N_lag; i_lag++){
		lag_vec[i_lag] = (lagh-lagl)/(N_lag-1)*i_lag+lagl;  
	}         
	
	a_vec[0] = a_l;
	a_vec[1] = a_h;

	pi[0][0] = 0.946;
    pi[0][1] = 0.054;

	pi[1][0] = 0.054;
    pi[1][1] = 0.946;

	//policy_input1();

	//simulation();

	policy_input0();

	for (int i_rho=0; i_rho<N_shk; i_rho++){	
		for (int i_k=0; i_k<Nk; i_k++){   
			for (int i_l=0; i_l<N_lag; i_l++){   
				
				double tmp_b0, tmp_b1, tmp_b2, tmp_b3, tmp_b4, tmp_b5, tmp_b6;
				double tmp_k0, tmp_lag0;

				tmp_k0 = k_vec[i_k];
				tmp_lag0 = lag_vec[i_l];

				if (i_rho==0){
				tmp_b0 = 0.1853;
				tmp_b1 = 1.0453;
				tmp_b2 = -0.0516;
				tmp_b3 = -0.0433;
				tmp_b4 = -0.1886;
				tmp_b5 = -0.1507;
				}

				if (i_rho==1){
				tmp_b0 = 0.1929;
				tmp_b1 = 1.0644;
				tmp_b2 = -0.0470;
				tmp_b3 = -0.0471;
				tmp_b4 = -0.2043;
				tmp_b5 = -0.1592;
				}

				policy_k1_1[i_k][i_l][i_rho] = tmp_b0 + tmp_b1*tmp_k0 + tmp_b2*tmp_lag0
					+ tmp_b3*tmp_k0*tmp_k0 + tmp_b4*tmp_lag0*tmp_lag0 + tmp_b5*tmp_k0*tmp_lag0;

				if (i_rho==0){
				tmp_b0 = 0.5854;
				tmp_b1 = -0.0682;
				tmp_b2 = -0.6583;
				tmp_b3 = 0.0080;
				tmp_b4 = 0.1408;
				tmp_b5 = 0.0404;
				}

				if (i_rho==1){
				tmp_b0 = 0.5863;
				tmp_b1 = -0.0633;
				tmp_b2 = -0.6541;
				tmp_b3 = 0.0069;
				tmp_b4 = 0.1347;
				tmp_b5 = 0.0389;
				}

				policy_l_1[i_k][i_l][i_rho] = tmp_b0 + tmp_b1*tmp_k0 + tmp_b2*tmp_lag0
					+ tmp_b3*tmp_k0*tmp_k0 + tmp_b4*tmp_lag0*tmp_lag0 + tmp_b5*tmp_k0*tmp_lag0;

				if (i_rho==0){
				tmp_b0 = 0.0984;
				tmp_b1 = 0.2100;
				tmp_b2 = -0.1423;
				tmp_b3 = -0.0250;
				tmp_b4 = 0.0476;
				tmp_b5 = -0.0673;
				}

				if (i_rho==1){
				tmp_b0 = 0.1024;
				tmp_b1 = 0.2158;
				tmp_b2 = -0.1475;
				tmp_b3 = -0.0259;
				tmp_b4 = 0.0483;
				tmp_b5 = -0.0703;
				}

				policy_c_1[i_k][i_l][i_rho] = tmp_b0 + tmp_b1*tmp_k0 + tmp_b2*tmp_lag0
					+ tmp_b3*tmp_k0*tmp_k0 + tmp_b4*tmp_lag0*tmp_lag0 + tmp_b5*tmp_k0*tmp_lag0;

				if (i_rho==0){
				tmp_b0 = 0.1956;
				tmp_b1 = 0.0414;
				tmp_b2 = 0.3592;
				tmp_b3 = -0.0271;
				tmp_b4 = 0.2398;
				tmp_b5 = 0.0892;
				}

				if (i_rho==1){
				tmp_b0 = 0.1967;
				tmp_b1 = 0.0405;
				tmp_b2 = 0.3542;
				tmp_b3 = -0.0264;
				tmp_b4 = 0.2430;
				tmp_b5 = 0.0879;
				}

				policy_lag_1[i_k][i_l][i_rho] = tmp_b0 + tmp_b1*tmp_k0 + tmp_b2*tmp_lag0
					+ tmp_b3*tmp_k0*tmp_k0 + tmp_b4*tmp_lag0*tmp_lag0 + tmp_b5*tmp_k0*tmp_lag0;

			}
		}
	}     

	policy_input1();

	//update the policy functions:
		for (int i_rho=0; i_rho<N_shk; i_rho++){	
			for (int i_k=0; i_k<Nk; i_k++){   
				for (int i_l=0; i_l<N_lag; i_l++){        
					
					double tmp_update;

					policy_k1_0[i_k][i_l][i_rho] = policy_k1_1[i_k][i_l][i_rho];  
					policy_lag_0[i_k][i_l][i_rho] = policy_lag_1[i_k][i_l][i_rho];
					policy_c_0[i_k][i_l][i_rho] = policy_c_1[i_k][i_l][i_rho];
					policy_l_0[i_k][i_l][i_rho] = policy_l_1[i_k][i_l][i_rho];
			   
				}
			}
		}

	simulation();
cout<<"sim"<<endl;


	int iter = 0;

 	do{  
	
		iter += 1;
		//update the policy functions:
		for (int i_rho=0; i_rho<N_shk; i_rho++){	
			for (int i_k=0; i_k<Nk; i_k++){   
				for (int i_l=0; i_l<N_lag; i_l++){        
					
					double tmp_update;

					tmp_update = (policy_k1_0[i_k][i_l][i_rho] + policy_k1_1[i_k][i_l][i_rho])/2.0;
					policy_k1_0[i_k][i_l][i_rho] = tmp_update;

					tmp_update = (2.0*policy_lag_0[i_k][i_l][i_rho] + 2.0*policy_lag_1[i_k][i_l][i_rho])/4.0;
					policy_lag_0[i_k][i_l][i_rho] = tmp_update;

					policy_c_0[i_k][i_l][i_rho] = policy_c_1[i_k][i_l][i_rho];

					tmp_update = (policy_l_0[i_k][i_l][i_rho] + policy_l_1[i_k][i_l][i_rho])/2.0;
					policy_l_0[i_k][i_l][i_rho] = tmp_update;
			   
				}
			}
		}

		policy_eul_compute( );
		
		cout<<iter<<endl;

	}while (!check_euler());
		

	//find the domain of lag
	double max_lag, min_lag;
	max_lag = -100;
	min_lag = 100;

	for (int i_shk=0; i_shk<N_shk; i_shk++){	
		fout<<"*********************************"<<endl;
		for (int i_k=0; i_k<Nk; i_k++){
			for (int i_lag=0; i_lag<N_lag; i_lag++){
			
			    k0 = k_vec[i_k];
				shk0 = i_shk;  
				lag0 = lag_vec[i_lag];
				
			    double *fvec;
				int iflag;
				int info;
				int lwa;
				int n = 4;
				double tol = 1e-16;
				double *wa;
	            double *xx;

				lwa = ( n * ( 3 * n + 13 ) ) / 2;
				fvec = new double[n];
				wa = new double[lwa];
				xx = new double[n];

				xx[0] = policy_k1_0[i_k][i_lag][i_shk];
				xx[1] = policy_l_0[i_k][i_lag][i_shk];
				xx[2] = policy_c_0[i_k][i_lag][i_shk];
				xx[3] = policy_lag_0[i_k][i_lag][i_shk];

				if (xx[3] > max_lag){
					max_lag = xx[3];
				}
    			if (xx[3] < min_lag){
					min_lag = xx[3];
				}

				iflag = 1;
				eul_f ( n, xx, fvec, &iflag );

				info = hybrd1 ( eul_f, n, xx, fvec, tol, wa, lwa );

				if (fvec[0]+fvec[1]+fvec[2]+fvec[3] <= 0.0001)
				{
					fout<<k0<<" "<<lag0<<" "
					 <<policy_k1_1[i_k][i_lag][i_shk]<<" "
					 <<policy_lag_1[i_k][i_lag][i_shk]<<" "
					 <<policy_c_1[i_k][i_lag][i_shk]<<" "
					 <<policy_l_1[i_k][i_lag][i_shk]<<" "    
					 <<endl;
				}

				delete [] fvec;
				delete [] wa;
				delete [] xx;  		  
     
			}
		}
	}

	cout<<"lag: "<<min_lag<<" "<<max_lag<<endl;

	simulation();



//step #: report the running time.
	time (&end);
	DP  dif = difftime (end,start);
    fout<<"Running time: "<< dif/60 <<" minutes."<< endl;

	return 0;
}
